#!/usr/bin/env python

"""
mod_python adapter.
"""

import WebStack.ModPython
from mod_python import apache

def dispatch(request, resource, debug=0):

    """
    Dispatch the given 'request' to the root application-specific 'resource'.
    The optional 'debug' flag, if set to 1, causes tracebacks to be displayed in
    the browser.
    """

    trans = WebStack.ModPython.Transaction(request)

    # NOTE: Resource pooling may be appropriate.

    try:
        resource.respond(trans)
        return apache.OK
    except:

        # NOTE: Error conditions should be investigated further, along with
        # NOTE: other response states.

        if not debug:
            return apache.HTTP_INTERNAL_SERVER_ERROR
        else:
            raise

# vim: tabstop=4 expandtab shiftwidth=4
